/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Fri Apr 19 16:40:35 EDT 2002
    copyright            : (C) 2002 by Stan Benoit
    email                : troff@nakedsoul.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** change log ******
-10 jul 02
	add 2> /dev/null to 'find' command

-21 jun 02
	add support for bkpinfo->nonbootable_backup
-19 apr 02
	add main function begin comment and debug conditional
  compitlation  Stan Benoit
-21 apr 02
	add debug statements to build a run tree. Stan Benoit

**** end change log **********/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "my-stuff.h"
#include "mondoarchive.h"
#include "mondostructures.h"




extern void set_signals(int);


int
main (int argc, char *argv[])
{

  /** init varaibles **/

  res = 0;
  retval = 0;
  diffs = 0;

  g_text_mode = TRUE;
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() \n");
  log_trace (trace_log);
#endif /* DEBUG */
  if (getuid () != 0)
    {
      fprintf (stderr, "Please run as root.\r\n");
      exit (127);
    }
  srandom (time (NULL));
  set_signals(TRUE);

/** debug statements **/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to unlink()\n");
  log_trace (trace_log);
#endif /* DEBUG */

  unlink (MONDO_TRACEFILE);
  unlink (MONDO_LOGFILE);
  unlink ("/tmp/changed.files");
  say_at_end[0] = '\0';
  printf ("Initializing...\n");

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to call_program_and_get_last_line()\n");
  log_trace (trace_log);
#endif /* DEBUG */

  strcpy (g_mondo_home,
	  call_program_and_get_last_line_of_output
	  ("find /usr/{local,share} -name mondo -follow -type d -maxdepth 2 2> /dev/null| grep -v \"1\\.[2-9]x\""));

  if (g_mondo_home[0] == '\0')
    {
      printf ("Still initializing :-) ...\n");

/** DEBUG info *******/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to call_program_and_get_last_line_of_output()\n");
      log_trace (trace_log);
#endif /* DEBUG */

      strcpy (g_mondo_home,
	      call_program_and_get_last_line_of_output
	      ("find /usr -type d -name mondo -follow -maxdepth 3 | grep -v \"1\\.[2-9]x\""));
    }
  if (g_mondo_home[0] == '\0')
    {
      fprintf (stderr,
	       "Cannot find Mondo's homedir. I think you have >1 'mondo' directory on your hard disk. Please delete the superfluous 'mondo' directories and try again\n");
      exit (1);
    }
  sprintf (tmp, "%s/restore-scripts.tgz", g_mondo_home);
  if (!does_file_exist (tmp))
    {
      fprintf (stderr,
	       "Cannot find Mondo's homedir. I think you have >1 'mondo' directory on your hard disk. Please delete the superfluous 'mondo' directories and try again..\n");
      exit (1);
    }
  sprintf (tmp, "Mondo Archive v%s --- http://www.mondorescue.com",
	   VERSION);

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to log_it()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  log_it (tmp);

  sprintf (tmp, "g_mondo_home = %s", g_mondo_home);
  /*  log_it(tmp); */
  bkpinfo = &bkpinfo_record;
  reset_bkpinfo (bkpinfo);
  bkpinfo->postnuke_tarball[0] = g_startdir[0] = bkpinfo->nfs_mount[0] = '\0';

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to handel_incoming_parameters()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  res = handle_incoming_parameters (argc, argv, bkpinfo);

  if (res)
    {
      fprintf (stderr,
	       "Bad parameters. Type 'man mondoarchive' to see manual. Mondo will now exit.\n");
      exit (res);
    }
  printf ("See %s for details of backup run.\n", MONDO_LOGFILE);

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to run_program_and_log_output()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  if (run_program_and_log_output ("mount | grep cdrom | grep super") == 0)
    {
      remount_cdrom_at_end = TRUE;

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to run_program_and_log_output()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      run_program_and_log_output ("umount /mnt/cdrom");
    }

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to setup_newt_stuff()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  setup_newt_stuff ();

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to some_basic_system_sanity_checks()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  res = some_basic_system_sanity_checks (bkpinfo);

  retval += res;
  if (res)
    {
      fatal_error ("Your distribution did not pass Mondo's sanity test.");
    }

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to run_program_and_log_output()\n");
  log_trace (trace_log);
#endif /* DEBUG */

  run_program_and_log_output ("cat /proc/cpuinfo");

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to run_program_and_log_output()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  run_program_and_log_output ("uname -a");
  run_program_and_log_output ("cat /etc/*issue*");

  /*
     sprintf(bkpinfo->call_make_iso, "cdrecord -eject fs=4m blank=fast dev=%s speed=%d /root/images/mondo/temporary.iso", "0,0,0", 4);

     if (eval_call(bkpinfo, bkpinfo->call_make_iso, "/tmp/test.dat", 1, MONDO_LOGFILE, "test stuff"))
     { finish(1); }
     else
     { finish(0); }
   */

/*
write_image_to_floppy("/dev/fd0", "/root/images/mindi/mindi-data-1.img");
finish(0);
*/

  if (bkpinfo->backup_data)
    {
      if (strlen (bkpinfo->tmpdir) < 2 || strlen (bkpinfo->scratchdir) < 2)
	{
	  fatal_error ("tmpdir or scratchdir are blank/missing");
	}

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to prepare_filelist()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      res = prepare_filelist (bkpinfo);	/* generate scratchdir/filelist.full */

      if (retval += res)
	{
	  fatal_error ("Failed to generate filelist catalog");
	}

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to call_filelist_chopper()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      call_filelist_chopper (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to copy_mondo_and_mindi_stuff_to_scratchdir()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      copy_mondo_and_mindi_stuff_to_scratchdir (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to call_mindi_to_supply_boot_disks()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      res = call_mindi_to_supply_boot_disks (bkpinfo);
      if (retval += res)
	{
	  fatal_error ("Failed to generate boot+data disks");
	}
      if (bkpinfo->include_paths[0] == '\0')
	{
	  fatal_error ("Why no backup path?");
	}

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to do_that_initial_stuff_dude()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      retval += do_that_initial_stuff_dude (bkpinfo);

/** DEBUG info ***/

#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to estimate_noof_media_required()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      estimate_noof_media_required (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to make_those_afios_dude()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      retval += make_those_afios_dude (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to make_those_slices_dude()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      retval += make_those_slices_dude (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to do_that_final_stuff_dude()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      retval += do_that_final_stuff_dude (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr, "In function main() call to log_it()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      log_it ("Dude, those archives have been made.");

      if (retval)
	{
	  strcat (say_at_end,
		  "Data archived. Please check the logs, just as a precaution. ");
	}
      else
	{
	  strcat (say_at_end, "Data archived OK. ");
	}
    }
  if (bkpinfo->verify_data)
    {
      if (bkpinfo->using_tape || bkpinfo->using_cdstream)
	{
	  chdir ("/");
	  mvaddstr_and_log_it (g_currentY, 0,
			       "Verifying archives against live filesystem");
	  if (bkpinfo->using_cdstream)
	    {
	      strcpy (bkpinfo->media_device, "/dev/cdrom");
	    }

/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to verify_tape_backups()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  verify_tape_backups (bkpinfo);

/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to mvaddstr_and_log_it()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  mvaddstr_and_log_it (g_currentY++, 74, "Done.");

	}
      else
	{
	  chdir ("/");
	  for (g_current_media_number = 1;
	       g_current_media_number < 99 && bkpinfo->verify_data;
	       g_current_media_number++)
	    {
	      res = verify_cd_image (bkpinfo);
	      retval += res;
	      if (res)
		{
		  sprintf (tmp,
			   "Warnings/errors were reported while checking CD #%d",
			   g_current_media_number);

/** DEBUG info ***/
#ifdef DEBUG
		  trace_log_ptr = trace_log;
		  sprintf (trace_log_ptr,
			   "In function main() call to log_to_screen()\n");
		  log_trace (trace_log);
#endif /* DEBUG */
		  log_to_screen (tmp);

		}
	    }
	  sprintf (tmp,
		   "cat %s | grep \"afio: \" | cut -d'\"' -f2 | sort -u | awk '{print \"/\"$0;};' | tr -s '/' '/' | grep -vx \"/afio:.*\" > /tmp/changed.files",
		   MONDO_LOGFILE);
	  if (system (tmp))
	    {
/** DEBUG info ***/
#ifdef DEBUG
	      trace_log_ptr = trace_log;
	      sprintf (trace_log_ptr,
		       "In function main() call to log_it()\n");
	      log_trace (trace_log);
#endif /* DEBUG */
	      log_it
		("Warning - unable to check logfile to derive list of changed files");

	    }
	}
	/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to count_lines_in_file()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      diffs = count_lines_in_file ("/tmp/changed.files");

      if (diffs > 0)
	{
	  sprintf (tmp,
		   "%ld files differed from live filesystem; type 'less /tmp/changed.files' to see. ",
		   diffs);
/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr, "In function main() call to log_it()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  log_it (tmp);

	  sprintf (tmp, "Data verified. %ld files differ. ", diffs);
	  strcat (say_at_end, tmp);
	  retval++;
	}
      else
	{
	  strcat (say_at_end, "All data verified OK. ");
	}
    }
  if (bkpinfo->backup_data)
    {
	/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to mvaddstr_and_log_it()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      mvaddstr_and_log_it (g_currentY, 0,
			   "Writing boot+data floppy images to disk");
      if (g_skip_floppies)
	{
/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to mvaddstr_and_log_it()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  mvaddstr_and_log_it (g_currentY++, 74, "Skip'd");
	}
      else
			/** DEBUG info ***/
#ifdef DEBUG
	trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to does_file_exist()\n");
      log_trace (trace_log);
#endif /* DEBUG */

      if (!does_file_exist ("/root/images/mindi/mindi-boot.1722.img"))
	{
/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to mvaddstr_and_log_it()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  mvaddstr_and_log_it (g_currentY++, 74, "No Imgs");
	/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to does_file_exist()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  if (does_file_exist ("/root/images/mindi/mindi.iso"))
	    {
/** DEBUG info ***/
#ifdef DEBUG
	      trace_log_ptr = trace_log;
	      sprintf (trace_log_ptr,
		       "In function main() call to popup_and_OK()\n");
	      log_trace (trace_log);
#endif /* DEBUG */
	      popup_and_OK
		("Boot+data floppy creation failed. However, FYI, you may burn /root/images/mindi/mindi.iso to a CD and boot from that instead if you wish.");
	    }
	}
      else
	{
/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to offer_to_write_floppies()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  offer_to_write_floppies (bkpinfo, "/root/images/mindi");
/** DEBUG info ***/
#ifdef DEBUG
	  trace_log_ptr = trace_log;
	  sprintf (trace_log_ptr,
		   "In function main() call to mvaddstr_and_log_it()\n");
	  log_trace (trace_log);
#endif /* DEBUG */
	  mvaddstr_and_log_it (g_currentY++, 74, "Done.");
	}
    }
  if (!res)
    {
/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to mvaddstr_and_lot_it()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      mvaddstr_and_log_it (g_currentY++, 0,
			   "Backup and/or verify ran to completion. Everything appears to be fine.");
    }
  else
/** DEBUG info ***/
#ifdef DEBUG
    trace_log_ptr = trace_log;
  sprintf (trace_log_ptr,
	   "In function main() call to mvaddstr_and_log_it()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  {
    mvaddstr_and_log_it (g_currentY++, 0,
			 "Backup and/or verify ran to completion. However, errors did occur.");
  }
/*  sleep(3); */
  sprintf (tmp, "rm -Rf %s", bkpinfo->scratchdir);
/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to system()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  system (tmp);
  sprintf (tmp, "rm -Rf %s", bkpinfo->tmpdir);
/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to system()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  system (tmp);

/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to does_file_exist()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  if (does_file_exist ("/root/images/mindi/mindi.iso"))
    {
/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr, "In function main() call to log_to_screen()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      log_to_screen
	("/root/images/mindi/mindi.iso, a boot/utility CD, is available if you want it");
    }
/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to length_of_file()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  if (length_of_file ("/tmp/changed.files") > 2)
    {
/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr, "In function main() call to log_to_screen()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      log_to_screen
	("Type 'less /tmp/changed.files' to see which files don't match the archives");
    }
  else
    {
      unlink ("/tmp/changed.files");
    }
/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to log_to_screen()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  log_to_screen (say_at_end);
  sprintf (tmp, "rm -Rf %s %s", bkpinfo->tmpdir, bkpinfo->scratchdir);
/** DEBUG info ***/
#ifdef DEBUG
  trace_log_ptr = trace_log;
  sprintf (trace_log_ptr, "In function main() call to system()\n");
  log_trace (trace_log);
#endif /* DEBUG */
  system (tmp);
  if (!g_text_mode)
    {
/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr, "In function main() call to popup_and_OK()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      popup_and_OK
	("Mondo Archive has finished its run. Please press ENTER to return to the shell prompt.");

/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr, "In function main() call to newtFinished()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      newtFinished ();
      printf ("See %s for details of backup run.\n", MONDO_LOGFILE);
    }
  if (remount_cdrom_at_end)
    {
/** DEBUG info ***/
#ifdef DEBUG
      trace_log_ptr = trace_log;
      sprintf (trace_log_ptr,
	       "In function main() call to run_program_and_log_output()\n");
      log_trace (trace_log);
#endif /* DEBUG */
      run_program_and_log_output ("mount /mnt/cdrom");
    }
  run_program_and_log_output("rm -f /var/cache/mondo-archive/last-backup.aborted");
  set_signals(FALSE);
  exit (retval);

  return EXIT_SUCCESS;
}





