/***************************************************************************
                          mondoarchive.h  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by Stan Benoit
    email                : troff@nakedsoul.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "my-stuff.h"


/** defines ****************************************************************/

/** strings ****************************************************************/
#define MONDO_MKISOFS_NONBOOT	"mkisofs -r -p MondoRescue -P www.mondorescue.com -A Mondo_Rescue_GPL_Version -V _CD#_"
#define MONDO_MKISOFS_REGULAR_SYSLINUX	"mkisofs -b isolinux.bin -no-emul-boot -boot-info-table -c boot.cat -boot-load-size 4 -r -p MondoRescue -P www.mondorescue.com -A Mondo_Rescue_GPL_Version -V _CD#_"
#define MONDO_MKISOFS_REGULAR_LILO      "mkisofs -b images/mindi-boot.2880.img -c boot.cat -J -r -p MondoRescue -P www.microwerks.net/~hugo/ -A Mondo_Rescue_GPL -V _CD#_"
#define MONDO_TMPISOS "/temporary.iso"
#define MONDO_POPMSG  "Your PC will not retract the CD tray automatically. Please call mondoarchive with the -m (manual CD tray) flag."

/** int's  *****************************************************************/
int g_current_media_number;
int res;
int retval;


/** char's *****************************************************************/

/** bool's *****************************************************************/
bool remount_cdrom_at_end;
bool g_skip_floppies;
bool g_text_mode;


/** long's ******************************************************************/
long diffs;

/** external fucntions ******************************************************/
extern long g_start_time;

extern long g_minimum_progress;

extern long g_maximum_progress;

extern long g_current_progress;

extern long g_currentY;												/* declared in mondo-tools.c */

/** Structures ************************************************************/
struct s_bkpinfo bkpinfo_record, *bkpinfo;

/** Buffer *****************************************************************/
char g_startdir[MAX_STR_LEN];	
char g_mondo_home[MAX_STR_LEN];	
char tmp[MAX_STR_LEN];	
char say_at_end[MAX_STR_LEN];	

/** extern buffer *********************************   *********************/
extern char err_log_lines[NOOF_ERR_LINES][MAX_STR_LEN];



void terminate_daemon(int);
void termination_in_progress(int);
void set_signals(int);

/**************************************************************************
 * Local prototypes  for mondo-archive.c                                  *
 **************************************************************************/

/** wipe out temp and scratch dirs ****************************************/
void wipe_temp_and_scratch_dirs (struct s_bkpinfo *bkpinfo);

/** find CDRW Devide ******************************************************/
int find_cdrw_device (char *);	/* SCSI NODE */

/** purpose ***************************************************************/
int eval_call (struct s_bkpinfo *, char *, char *, int, char *, char *);

/** purpose ***************************************************************/
int handle_incoming_parameters (int argc, char *argv[],
				struct s_bkpinfo *bkpinfo);

/** Process command line args *********************************************/
int process_switches (struct s_bkpinfo *bkpinfo,
		      char flag_val[128][MAX_STR_LEN], bool flag_set[128]);

/** purpose ***************************************************************/
void resolve_naff_tokens (char *, char *, char *, char *);

/** Get users set switches from command line arguments ********************/
int retrieve_switches_from_command_line (int argc, char *argv[],
					 char flag_val[128][MAX_STR_LEN],
					 bool flag_set[128]);

/** purposer **************************************************************/
void store_nfs_config (struct s_bkpinfo *);

/** Sanity checks as listed:              *********************************/
int some_basic_system_sanity_checks ();

/** purpose  **************************************************************/
void copy_mondo_and_mindi_stuff_to_scratchdir (struct s_bkpinfo *bkpinfo);

/** purpose  **************************************************************/
void estimate_noof_media_required (struct s_bkpinfo *bkpinfo);

/***************************************************************************
 * Externals used by mondo-archive.c                                       *
 ***************************************************************************/

/***************************************************************************
 * log_trace() -- found in mondo-tools.c                                   *
 * Purpose:                                                                *
 ***************************************************************************/
extern void log_trace (char *o);

/***************************************************************************
 * add_files_to_cd() -- found in x.c                                       *
 * Purpose:                                                                *
 ***************************************************************************/
extern int add_files_to_cd (struct s_bkpinfo *,
			    char
			    list_of_files[ARBITRARY_MAXIMUM][MAX_STR_LEN],
			    int);

/***************************************************************************
 * add_files_to_media() -- found in x.c                                    *
 * Purpose:                                                                *
 ***************************************************************************/
extern int add_files_to_media (struct s_bkpinfo *,
			       char
			       list_of_files[ARBITRARY_MAXIMUM][MAX_STR_LEN],
			       int);

/***************************************************************************
 * add_file_to_tape() -- found in x.c                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int add_file_to_tape (struct s_bkpinfo *, char *);

/***************************************************************************
 * ask_me_yes_or_no() -- found in x.c                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int ask_me_yes_or_no (char *);

/***************************************************************************
 * ask_me_OK_or_cancel() -- found in x.c                                   *
 * Purpose:                                                                *
 ***************************************************************************/
extern int ask_me_OK_or_cancel (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *calc_checksum_of_file (char *filename);







/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *call_program_and_get_last_line_of_output (char *call);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void call_filelist_chopper (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int call_mindi_to_supply_boot_disks (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void center_string (char *, int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int chop_filelist (char *, char *, long);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void close_evalcall_form (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void close_progress_form (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long count_lines_in_file (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern bool does_file_exist (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int do_that_initial_stuff_dude (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int do_that_final_stuff_dude (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void exclude_nonexistent_files (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void fatal_error (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int find_and_mount_actual_cd (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int find_cdrom_device (char *);	/* /dev entry */

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void finish (int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long friendly_sizestr_to_sizelong (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int get_last_filelist_number (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long get_time (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int grab_percentage_from_last_line_of_file (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *last_line_of_file (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long long length_of_file (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void log_file_end_to_screen (char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void log_it (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void log_tape_pos (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void log_to_screen (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_afioballs_and_images (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_checksum_list_file (char *, char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_iso_fs (struct s_bkpinfo *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_slices_and_images (struct s_bkpinfo *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_tape_archives (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_those_afios_dude (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int make_those_slices_dude (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *marker_to_string (int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int mount_CDROM_here (char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void mvaddstr_and_log_it (int, int, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *number_to_text (int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int offer_to_write_floppies (struct s_bkpinfo *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int openin_tape (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int openout_tape (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void open_evalcall_form (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void open_progress_form (char *, char *, char *, char *, long);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void pause_and_ask_for_cdr (int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void popup_and_OK (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern bool popup_and_get_string (char *, char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int prepare_filelist (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void process_to_buffer_tape_IO (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int read_cfg_var (char *, char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int read_file_from_tape_to_file (struct s_bkpinfo *, char *,
					long long);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int read_file_from_tape_to_stream (struct s_bkpinfo *, FILE *,
					  long long);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int read_header_block_from_tape (long long *, char *, int *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void reset_bkpinfo (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int run_program_and_log_output (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int run_program_and_log_to_screen (char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void setup_newt_stuff (void);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long size_of_all_biggiefiles_K (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *slice_fname (long, long, char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int slice_up_file_etc (struct s_bkpinfo *, char *, long, long);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern long long space_occupied_by_cd (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int strcmp_inc_numbers (char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *strip_afio_output_line (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void strip_spaces (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int tar_this_set (struct s_bkpinfo *, char *, char *, int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char *trim_empty_quotes (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void update_evalcall_form (int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void update_progress_form (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern char which_boot_loader (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int verify_cd_image (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int verify_tape_backups (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_cfg_var (char *, char *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_data_disks_to_tape (char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_file_to_tape_from_file (struct s_bkpinfo *, char *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_header_block_to_tape (long long, char *, int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern void wrong_marker (int, int);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_one_liner_data_file (char *fname, char *contents);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_final_iso_if_necessary (struct s_bkpinfo *);

/***************************************************************************
 * () -- found in x.c                                                      *
 * Purpose:                                                                *
 ***************************************************************************/
extern int write_iso_and_go_on (struct s_bkpinfo *, bool);




