/***************************************************************************
                          mondotarme.h  -  description
                             -------------------
    begin                : Sun Apr 21 2002
    copyright            : (C) 2002 by Stan Benoit
    email                : troff@nakedsoul.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** externals *************************************************************/

extern long g_noof_sets;

extern long g_start_time;
extern long g_minimum_progress;
extern long g_maximum_progress;
extern long g_current_progress;
extern long g_currentY;		/* declared in mondo-tools.c */

extern char err_log_lines[NOOF_ERR_LINES][MAX_STR_LEN];

extern bool g_debugging;
extern bool g_running_live;
extern bool g_text_mode;
extern bool g_cd_recovery;
extern bool g_skip_floppies;

extern char *g_kernel_path;

extern FILE *g_tape_stream;
extern long long g_tape_posK;
extern int g_current_media_number;
extern newtComponent g_progressForm;


/** added s.benoit 21 apr 02 for debuging **/
extern void log_trace (char *);

extern int ask_me_yes_or_no (char *);
extern char *calc_checksum_of_file (char *filename);
extern void center_string (char *, int);
extern void close_evalcall_form (void);
extern void close_progress_form (void);
extern long count_lines_in_file (char *);
extern bool does_file_exist (char *);
extern int eval_call (struct s_bkpinfo *, char *, char *, int, char *,
		      char *);
extern void fatal_error (char *);
extern int get_last_filelist_number (struct s_bkpinfo *);
extern char *last_line_of_file (char *);
extern long long length_of_file (char *);
extern void log_file_end_to_screen (char *, char *);
extern void log_it (char *);
extern void log_tape_pos (void);
extern void log_to_screen (char *);
extern void mvaddstr_and_log_it (int, int, char *);
extern void open_evalcall_form (char *);
extern void open_progress_form (char *, char *, char *, char *, long);
extern int openin_tape (struct s_bkpinfo *);
extern int openout_cdstream (char *, int);
extern int openout_tape (char *);
extern void pause_and_ask_for_cdr (int);
extern void popup_and_OK (char *);
extern bool popup_and_get_string (char *, char *, char *);
extern int run_program_and_log_output (char *);
extern int run_program_and_log_to_screen (char *, char *);
extern long size_of_all_biggiefiles_K (struct s_bkpinfo *);
extern char *slice_fname (long, long, char *, char *);
extern long long space_occupied_by_cd (char *);
extern void update_evalcall_form (int);
extern void update_progress_form (char *);
extern int verify_cd_image (struct s_bkpinfo *);
extern int write_data_disks_to_tape (char *);
extern int write_file_to_tape_from_file (struct s_bkpinfo *, char *);
extern int write_header_block_to_tape (long long, char *, int);


/** Locals **********************************************************/
int add_files_to_cd (struct s_bkpinfo *,
		     char list_of_files[ARBITRARY_MAXIMUM][MAX_STR_LEN], int);

int add_files_to_media (struct s_bkpinfo *,
			char list_of_files[ARBITRARY_MAXIMUM][MAX_STR_LEN],
			int);

int add_file_to_tape (struct s_bkpinfo *, char *);

int chop_filelist (char *, char *, long);

int do_that_initial_stuff_dude (struct s_bkpinfo *);

int make_iso_fs (struct s_bkpinfo *, char *);

int make_slices_and_images (struct s_bkpinfo *, char *);

int make_tape_archives (char *);

int make_afioballs_and_images (struct s_bkpinfo *);

void pause_and_ask_for_cdr (int);

int prepare_filelist (struct s_bkpinfo *);

int slice_up_file_etc (struct s_bkpinfo *, char *, long, long);

int tar_this_set (struct s_bkpinfo *, char *, char *, int);

int write_final_iso_if_necessary (struct s_bkpinfo *);

int write_iso_and_go_on (struct s_bkpinfo *, bool);

void wipe_archives (char *);
