/* my-stuff.h


06/19
- changed tape block size from 8192 to 16384

04/08
- added manual_cd_tray flag to bkpinfo

03/31
- added restore_path to struct s_bkpinfo

03/21
- updated version# to 1.42

02/20
- added bkpinfo->using_cdstream

02/06
- added MONDO_VERSION

02/02
- added MONDO_CFG_FILE
- added SLICE_SIZE

01/31
- removed MINDI_HOME: it is unnecessary
- replaced MONDO_HOME with variable g_mondo_home

01/25
- added MONDO_HOME, MINDI_HOME

01/21
- added s_node{} structure

01/17
- added sys/shm.h, types.h, ipc.h

01/02
- added that groovy bkpinfo{} stuff

11/29
- added raidlist{} struct

08/27
- stuff
*/

#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <getopt.h>
#include <errno.h>
#include <stddef.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>
#include <curses.h>
#include <newt.h>
#include <ctype.h>
#include <string.h>



#ifdef DEBUG
int count;
char trace_log[255];		/*buffer for logging */
char *trace_log_ptr;
#endif /* DEBUG */




/** added for debugging Stan Benoit 21 apr 2002 **/
#define MONDO_TRACEFILE	"/var/log/mondo-tracefile.log"
/** DEBUG add ****/

#define MONDO_CFG_FILE		"/tmp/mondo-restore.cfg"

#define CRC_M16	0xA001		/* crc-16 mask */
#define	CRC_MTT	0x1021		/* crc-ccitt mask */

#define FALSE 0
#define TRUE 1

#define SCREEN_LENGTH 25
#define NOOF_ERR_LINES 6
#define ARBITRARY_MAXIMUM 512	/* max items in mountlist, filelist editor window */
#define MAX_STR_LEN 512
#define MAXIMUM_RAID_DEVS 32
#define MAXIMUM_ADDITIONAL_RAID_VARS 32
#define MAXIMUM_DISKS_PER_RAID_DEV 32

#define MOUNTLIST_FNAME "/tmp/mountlist.txt"
#define RAIDTAB_FNAME "/etc/raidtab"

#define BLK_START_OF_BACKUP     1
#define BLK_START_OF_TAPE       2
#define BLK_START_AFIOBALLS	10
#define BLK_STOP_AFIOBALLS	19
#define BLK_START_AN_AFIO_OR_SLICE    	20
#define BLK_STOP_AN_AFIO_OR_SLICE	29
#define BLK_START_BIGGIEFILES	30
#define BLK_STOP_BIGGIEFILES	39
#define BLK_START_A_BIGGIE	40
#define BLK_STOP_A_BIGGIE	59
#define BLK_START_FILE          80
#define BLK_STOP_FILE           89
#define BLK_END_OF_TAPE         100
#define BLK_END_OF_BACKUP       101
#define BLK_ABORTED_BACKUP      102
#define TAPE_BLOCK_SIZE 32768	/* was 8192; changed on Juneteenth, 2002 */
#define MONDO_LOGFILE           "/var/log/mondo-archive.log"
#define TAPE_BUF_SIZE           1*1024
#define NOOF_TAPE_BUFS          4





#define BIGGIELIST_TXT "/tmp/biggielist.txt"
#define FILELIST_FULL "/tmp/filelist.full"
#define BIGGIELIST_POT "/tmp/tmpfs/biggielist.pot"
#define FILELIST_POTENTIAL "/tmp/tmpfs/filelist.potential"
#define FILELIST_IMAGEDEVS "/tmp/tmpfs/filelist.imagedevs"
#define FILELIST_RESTTHESE "/tmp/tmpfs/filelist.restore-these"
#define BIGGIELIST_RESTTHESE "/tmp/tmpfs/biggielist.restore-these"
#define IMAGEDEVS_POT "/tmp/tmpfs/imagedevs.pot"
#define IMAGEDEVS_RESTTHESE "/tmp/tmpfs/imagedevs.restore-these"


#define SLICE_SIZE 8192






